'*********************************************************************
'*                           EasyArc.vbs                             *
'*          .  *
'*       .          *
'*                                                                   *
'*                    :                     *
'*                       3.0  29.03.2017                     *
'* , ,   : http://iprg.ru/easyarc  *
'*********************************************************************
Dim ArcDir(100, 3) 
Dim ArcDir_Index
Dim ArcDir_Index_Target
Dim FolderNoDel(1000)
Dim FolderNoDel_Index
Dim FolderArc(1000)
Dim FolderArc_Index
Dim FSO
Dim WShell
Dim s_Script_Dir
Dim s_CFG_FileName
Dim s_ARC_EXE
Dim s_LOG_Dir
Dim s_ARC_MAX_SIZE
Dim LOGFile
Dim s_YearMonthDay
Dim n_MaxLoopDeleteArc

Sub Add_FolderNoDel(parStr)
    FolderNoDel(FolderNoDel_Index) = Trim(parStr)
    FolderNoDel_Index = FolderNoDel_Index + 1
End Sub 'Add_FolderNoDel(parStr)

Function Exist_FolderNoDel(parStr)
    s_ParStr = Trim(parStr)
    Res = False
    For n_CurRow = 0 To FolderNoDel_Index - 1
        If FolderNoDel(n_CurRow) = s_ParStr Then
            Res = True
        End If
    Next
    Exist_FolderNoDel = Res
End Function 'Exist_FolderNoDel(parStr)

Sub Add_FolderArc(parStr)
    FolderArc(FolderArc_Index) = Trim(parStr)
    FolderArc_Index = FolderArc_Index + 1
End Sub 'Add_FolderArc(parStr)

Sub FolderExistThenCreate(parFolder)
    If FSO.FolderExists(parFolder) = False Then
        LOGFile.WriteLine (" : " & parFolder)
        FSO.CreateFolder (parFolder)
    End If
End Sub 'FolderExistThenCreate(parFolder)

Function StrToDate(parStr)
    parStr = Trim(parStr)
    If Len(parStr) <> 8 Then
        StrToDate = ""
        Exit Function
    End If
    nDateNumeric = 1
    For n = 1 To 8
        If IsNumeric(Mid(parStr, n, 1)) = False Then
            nDateNumeric = 0
        End If
    Next
    If nDateNumeric = 0 Then
        StrToDate = ""
        Exit Function
    End If
    sDay = CLng(FormatNumber(Mid(parStr, 7, 3), 0))
    sMonth = CLng(FormatNumber(Mid(parStr, 5, 2), 0))
    sYear = CLng(FormatNumber(Mid(parStr, 1, 4), 0))
    nKorrData = 1
    If Not (sDay >= 1 And sDay <= 31) Then
        StrToDate = ""
        Exit Function
    End If
    If Not (sMonth >= 1 And sMonth <= 12) Then
        StrToDate = ""
        Exit Function
    End If
    If Not (sYear >= 1990 And sYear <= 2100) Then
        StrToDate = ""
        Exit Function
    End If
    StrToDate = DateSerial(sYear, sMonth, sDay)
End Function 'StrToDate(parStr)

Function FindOldestArc_And_Delete()
    LOGFile.WriteLine ("  ,        ...")
    Res_Date = "" 
    Res = "" 
    s_SubFoldersName = "" 
    For n_CurRow = 0 To ArcDir_Index - 1
        If FSO.FolderExists(ArcDir(n_CurRow, 0)) = True Then
            Set obFolder = FSO.GetFolder(ArcDir(n_CurRow, 0))
            
            For Each SubFolders In obFolder.SubFolders
                d_FolderDate = StrToDate(SubFolders.Name)
                
                If (d_FolderDate <> "" And Exist_FolderNoDel(SubFolders.Name) = False) Then
                    If Res_Date = "" Then
                        Res_Date = d_FolderDate
                        s_SubFoldersName = SubFolders.Name
                        Res = SubFolders.Path 
                    Else
                        If Res_Date > d_FolderDate Then
                            Res_Date = d_FolderDate
                            s_SubFoldersName = SubFolders.Name
                            Res = SubFolders.Path 
                        End If
                    End If
                    
                Else
                    If Exist_FolderNoDel(SubFolders.Name) = True Then
                        LOGFile.WriteLine ("(FolderNoDel): " & ArcDir(n_CurRow, 0) & SubFolders.Name)
                    Else
                        LOGFile.WriteLine (".........: " & ArcDir(n_CurRow, 0) & SubFolders.Name)
                    End If
                End If
            Next
        Else
            LOGFile.WriteLine (" ........: " & ArcDir(n_CurRow, 0))
        End If
    Next
    If Res = "" Then 
        LOGFile.WriteLine ("    ,       .")
    Else
        LOGFile.WriteLine ("  : " & Res)
        
        On Error Resume Next
        FSO.DeleteFolder Res, True
        If Err.Number > 0 Then
            LOGFile.WriteLine (" ....: " & Res)
            Add_FolderNoDel (s_SubFoldersName)
            LOGFile.WriteLine (" ...: " & Res)
        Else
            LOGFile.WriteLine (" ....: " & Res)
        End If
    End If

    FindOldestArc_And_Delete = Res
End Function 'FindOldestArc_And_Delete()

Function GetArcDirFreeSpace()
    Res = -1
    For n_CurRow = 0 To ArcDir_Index - 1
        If FSO.FolderExists(ArcDir(n_CurRow, 0)) = True Then
            Set obFolder = FSO.GetFolder(ArcDir(n_CurRow, 0))
            ArcDir(n_CurRow, 2) = CLng(FSO.GetDrive(FSO.GetDriveName(ArcDir(n_CurRow, 0))).FreeSpace / 1048576)
            
            Set obFolder = FSO.GetFolder(ArcDir(n_CurRow, 0))
            For Each SubFolders In obFolder.SubFolders
                If SubFolders.Name = s_YearMonthDay Then
                    LOGFile.WriteLine (" -->: " & ArcDir(n_CurRow, 0) & ",  : " & CStr(ArcDir(n_CurRow, 2) - ArcDir(n_CurRow, 1) - s_ARC_MAX_SIZE) & ", : " & CStr(ArcDir(n_CurRow, 1)) & ", : " & CStr(ArcDir(n_CurRow, 2)) & "")
                    LOGFile.WriteLine ("          ,    : " & s_YearMonthDay)
                    Res = n_CurRow
                    Exit For
                End If
            Next
            
            If Res = -1 Then
                If (ArcDir(n_CurRow, 2) - ArcDir(n_CurRow, 1) - s_ARC_MAX_SIZE) >= 0 Then
                    LOGFile.WriteLine (" -->: " & ArcDir(n_CurRow, 0) & ",  : " & CStr(ArcDir(n_CurRow, 2) - ArcDir(n_CurRow, 1) - s_ARC_MAX_SIZE) & ", : " & CStr(ArcDir(n_CurRow, 1)) & ", : " & CStr(ArcDir(n_CurRow, 2)) & "")
                    Res = n_CurRow
                    Exit For
                Else
                    LOGFile.WriteLine (".........: " & ArcDir(n_CurRow, 0) & ",  : " & CStr(ArcDir(n_CurRow, 2) - ArcDir(n_CurRow, 1) - s_ARC_MAX_SIZE) & ", : " & CStr(ArcDir(n_CurRow, 1)) & ", : " & CStr(ArcDir(n_CurRow, 2)) & "")
                End If
            Else
                Exit For
            End If
        Else
            ArcDir(n_CurRow, 2) = 0
            LOGFile.WriteLine (" ........: " & ArcDir(n_CurRow, 0))
        End If
    Next
    GetArcDirFreeSpace = Res
End Function 'GetArcDirFreeSpace()

Function EasyArc()
ArcDir_Index = 0
ArcDir_Index_Target = -1
n_MaxLoopDeleteArc = 100
FolderNoDel_Index = 0
FolderArc_Index = 0
s_Str = ""

s_Script_Dir = "C:\EasyArc\" 
s_CFG_FileName = "EasyArc.ini"  
s_LOG_Dir = "C:\EasyArc\LOG\"      
s_ARC_MAX_SIZE = 50             
s_ARC_EXE = "C:\Progra~1\WinRAR\rar.exe a -ac -r -v1100000k -m5 -ad -wC:\EasyArc\TEMP\"

days = Trim(CStr(Day(Date)))        
months = Trim(CStr(Month(Date)))    
years = Trim(CStr(Year(Date)))      
If Len(days) = 1 Then days = "0" & days
If Len(months) = 1 Then months = "0" & months
s_YearMonthDay = years & months & days
  

Set FSO = CreateObject("Scripting.FileSystemObject")
Set WShell = CreateObject("WSCript.shell")

If FSO.FileExists(s_Script_Dir & s_CFG_FileName) = False Then
   Set TextStream = FSO.CreateTextFile(s_Script_Dir & s_CFG_FileName, True)

   TextStream.WriteLine ("*********************************************************************")
   TextStream.WriteLine ("*                           EasyArc.vbs                             *")
   TextStream.WriteLine ("*          .  *")
   TextStream.WriteLine ("*       .          *")
   TextStream.WriteLine ("*                                                                   *")
   TextStream.WriteLine ("*                    :                     *")
   TextStream.WriteLine ("*                       3.0  29.03.2017                     *")
   TextStream.WriteLine ("* , ,   : http://iprg.ru/easyarc  *")
   TextStream.WriteLine ("*********************************************************************")
   TextStream.WriteLine ("ARC_MAX_SIZE: 80000")
   TextStream.WriteLine ("ARC_EXE: C:\Progra~1\WinRAR\rar.exe a -ac -r -v1100000k -m5 -ad -wC:\EasyArc\TEMP\")
   TextStream.WriteLine ("LOG: C:\EasyArc\LOG\")
   TextStream.WriteLine ("ARCDIR:(50000) \\server1\c$\Archives\")
   TextStream.WriteLine ("ARCDIR:(70000) \\server3\d$\Archives\")
   TextStream.WriteLine ("ARCDIR:(20000) \\server3\e$\Archives\")
   TextStream.WriteLine ("ARCDIR:(20000) \\server3\f$\Archives\")
   TextStream.WriteLine ("ARCDIR:(50000) \\server2\c$\Archives\")
   TextStream.WriteLine ("ARCDIR:(70000) \\server2\d$\Archives\")
   TextStream.WriteLine ("FolderArc: \\server1\PublicFolders\")
   TextStream.WriteLine ("FolderArc: \\server2\homefolders\")
   TextStream.WriteLine ("FolderArc: \\server2\Publicfolders\")
   TextStream.Close
End If

Set File = FSO.GetFile(s_Script_Dir & s_CFG_FileName)
Set TextStream = File.OpenAsTextStream(1)
While Not TextStream.AtEndOfStream
   s_Str = TextStream.ReadLine()
   If Left(s_Str, 1) = "*" Then
   ElseIf Trim(s_Str) = "" Then
   Else
      If Left(s_Str, 13) = "ARC_MAX_SIZE:" Then
        s_ARC_MAX_SIZE = CLng(Trim(Replace(s_Str, "ARC_MAX_SIZE:", "")))
        
      ElseIf Left(s_Str, 8) = "ARC_EXE:" Then
        s_ARC_EXE = Trim(Replace(s_Str, "ARC_EXE:", ""))
        
      ElseIf Left(s_Str, 4) = "LOG:" Then
        s_LOG_Dir = Trim(Replace(s_Str, "LOG:", ""))
        
      ElseIf Left(s_Str, 7) = "ARCDIR:" Then
        s_Str = Trim(Replace(s_Str, "ARCDIR:(", ""))
        ArcDir(ArcDir_Index, 0) = "" 
        ArcDir(ArcDir_Index, 1) = "" 
        ArcDir(ArcDir_Index, 2) = 0 
        n_CurSubStr = 0
        For n_NumRow = 1 To Len(s_Str)
            s_CurChar = Mid(s_Str, n_NumRow, 1)
            If s_CurChar = ")" Then
                n_CurSubStr = 1
            ElseIf n_CurSubStr = 0 Then
                ArcDir(ArcDir_Index, 1) = ArcDir(ArcDir_Index, 1) & s_CurChar
            ElseIf n_CurSubStr = 1 Then
                ArcDir(ArcDir_Index, 0) = ArcDir(ArcDir_Index, 0) & s_CurChar
            End If
        Next
        ArcDir(ArcDir_Index, 0) = Trim(ArcDir(ArcDir_Index, 0))
        ArcDir(ArcDir_Index, 1) = CLng(Trim(ArcDir(ArcDir_Index, 1)))
        ArcDir_Index = ArcDir_Index + 1
        
      ElseIf Left(s_Str, 12) = "FolderNoDel:" Then
        s_Str = Trim(Replace(s_Str, "FolderNoDel:", ""))
        Add_FolderNoDel (s_Str)
      ElseIf Left(s_Str, 10) = "FolderArc:" Then
        s_Str = Trim(Replace(s_Str, "FolderArc:", ""))
        Add_FolderArc (s_Str)
      End If
   End If
Wend
TextStream.Close

If FSO.FolderExists(s_LOG_Dir) = False Then
   FSO.CreateFolder (s_LOG_Dir)
End If

Set LOGFile = FSO.CreateTextFile(s_LOG_Dir & s_YearMonthDay & "_LOG.txt", True)
LOGFile.WriteLine (": " & FormatDateTime(Now, 0))
LOGFile.WriteLine ("")
LOGFile.WriteLine ("      1 : " & CStr(s_ARC_MAX_SIZE)) & ""

s_OldestArc = ""

n_CountLoop = 1 
n_ExitLoop = Flase 
s_TargetFolder = "" 
Do
    LOGFile.WriteLine ("")
    LOGFile.WriteLine (" : " & CStr(n_CountLoop))
    ArcDir_Index_Target = GetArcDirFreeSpace()
    n_ExitLoop = Flase
    
    If ArcDir_Index_Target < 0 Then 
        LOGFile.WriteLine ("       ...")
        s_OldestArc = FindOldestArc_And_Delete
        If s_OldestArc = "" Then
            n_ExitLoop = True
        End If
    Else 
        s_TargetFolder = ArcDir(ArcDir_Index_Target, 0) & s_YearMonthDay & "\"
        FolderExistThenCreate (s_TargetFolder) 
        n_ExitLoop = True
    End If
    
    n_CountLoop = n_CountLoop + 1
    If n_CountLoop > n_MaxLoopDeleteArc Then
        n_ExitLoop = True
    End If
Loop Until (n_ExitLoop = True)

If s_TargetFolder <> "" Then
    LOGFile.WriteLine ("    : " & s_TargetFolder)
    For n_CurRow = 0 To FolderArc_Index - 1
        If FSO.FolderExists(FolderArc(n_CurRow)) = True Then
            s_ArcFileName = FolderArc(n_CurRow)
    
            s_ArcFileName = Replace(s_ArcFileName, "\\", "")
            s_ArcFileName = Replace(s_ArcFileName, "$", "")
            s_ArcFileName = Replace(s_ArcFileName, "\", "_")
            s_ArcFileName = Replace(s_ArcFileName, ".", "_")
            s_ArcFileName = Replace(s_ArcFileName, ":", ")")
            s_ArcFileName = Replace(s_ArcFileName, " ", "_")
        
            s_CurArcString = s_ARC_EXE & " " & s_TargetFolder & s_ArcFileName & " """ & FolderArc(n_CurRow) & """"
            LOGFile.WriteLine (FormatDateTime(Now, 0) & "  : " & FolderArc(n_CurRow) & "        : " & s_CurArcString)
        
            Res_Exec = WShell.Run(s_CurArcString, 5, True)
            If Res_Exec > 0 Then
                LOGFile.WriteLine ("  ^     : " & CStr(Res_Exec) & Err.number & " - " & Err.Description)
            End If
        Else
            LOGFile.WriteLine (" ........: " & FolderArc(n_CurRow))
        End If
    Next

End If

LOGFile.WriteLine ("")
LOGFile.WriteLine (": " & FormatDateTime(Now, 0))
LOGFile.Close

End Function 'EasyArc

EasyArc
